/*
============================================================================
 Name        : CActiveAsyncIOAppUi.cpp
 Author      : 
 Copyright   : Your copyright notice
 Description : CCActiveAsyncIOAppUi implementation
============================================================================
*/

// To enable the dynamic loading of the menu with a Close command in the UDEB version
#include <eikmenub.h>
#include <eikedwin.h>
#include "CDialog.h"
#include "CFileWrite.h"
#include "CFileRead.h"

#include "CActiveAsyncIOApplication.h"

//             The second phase constructor of the application UI class.
//             The application UI creates and owns the one and only view.
// 
void CCActiveAsyncIOAppUi::ConstructL()
    {
	           // BaseConstructL() completes the UI framework's
	           // construction of the App UI.
    BaseConstructL();
	           // Create the single application view in which to
	           // draw the text message, passing into it
	           // the rectangle available to it.
	DialogResult dialogResult;
	dialogResult.fileSize = 1;
	dialogResult.Mode = 0;
	CDialog* dialog = new (ELeave) CDialog(dialogResult);
	TInt ret = dialog -> ExecuteLD(R_DIALOG);
	CFileIO* iWrite;
	if (dialogResult.Mode == 1)	
		iWrite = new (ELeave) CFileWrite(*(dialogResult.fileName), dialogResult.fileSize);
	else
		iWrite = new (ELeave) CFileRead(*(dialogResult.fileName), dialogResult.fileSize);
	iWrite->go();
	CActiveScheduler::Start();
	}


//             The app Ui owns the two views and is. 
//             therefore, responsible for destroying them
//
CCActiveAsyncIOAppUi::~CCActiveAsyncIOAppUi()
	{
	delete iAppView;
	}


//             Called by the UI framework when a command has been issued.
//             In this example, a command can originate through a 
//             hot-key press or by selection of a menu item.
//             The command Ids are defined in the .hrh file
//             and are 'connected' to the hot-key and menu item in the
//             resource file.
//             Note that the EEikCmdExit is defined by the UI
//             framework and is pulled in by including eikon.hrh
//
void CCActiveAsyncIOAppUi::HandleCommandL(TInt aCommand)
	{
	switch (aCommand)
		{
		      // Just issue simple info messages to show that
		      // the menu items have been selected
	case ECActiveAsyncIOItem0:
		iEikonEnv->InfoMsg(R_TEXT_ITEM0);
		break;

	
	case ECActiveAsyncIOItem1:
		iEikonEnv->InfoMsg(R_TEXT_ITEM1);
		break;
	
	case ECActiveAsyncIOItem2:
		iEikonEnv->InfoMsg(R_TEXT_ITEM2);
		break;
               // Exit the application. The call is
		       // implemented by the UI framework.

	case EEikCmdExit: 
		Exit();
		break;
		}
	}


// This is a way to dynamically initialize the menu.
// If it is the debug version, the menu should contain a Close command.
// In the release version, there should be no Close command.
#if defined(_DEBUG)
void CCActiveAsyncIOAppUi::DynInitMenuPaneL(TInt aMenuId, CEikMenuPane* aMenuPane)
	{
	if(aMenuId == R_FIRST_MENU)
		{
		CEikMenuPaneItem::SData itemData;
		TBuf<16> closeCommandText;
		iEikonEnv->ReadResource(closeCommandText, R_CLOSE_COMMAND);
		itemData.iText=closeCommandText;
		itemData.iCommandId=EEikCmdExit;
		itemData.iFlags=0;
		itemData.iCascadeId=0;
		aMenuPane->AddMenuItemL(itemData);
		}
	}
#endif
