/*
============================================================================
 Name        : RThreadSyncIOAppUi.cpp
 Author      : 
 Copyright   : Your copyright notice
 Description : CRThreadSyncIOAppUi implementation
============================================================================
*/

// To enable the dynamic loading of the menu with a Close command in the UDEB version
#include <eikmenub.h>
#include "CDialog.h"
#include "CFileIO.h"
#include "CFileWrite.h"
#include "CFileRead.h"
#include "CSummaryDialog.h"

#include "RThreadSyncIOApplication.h"

//             The second phase constructor of the application UI class.
//             The application UI creates and owns the one and only view.
// 
void CRThreadSyncIOAppUi::ConstructL()
    {
	           // BaseConstructL() completes the UI framework's
	           // construction of the App UI.
    BaseConstructL(ENoAppResourceFile );
	           // Create the single application view in which to
	           // draw the text message, passing into it
	           // the rectangle available to it.
	DialogResult dialogResult;
	dialogResult.fileSize = 1;
	dialogResult.Mode = 0;
	CDialog* dialog = new (ELeave) CDialog(dialogResult);
	TInt ret = dialog -> ExecuteLD(R_DIALOG);

	CFileIO* iWrite;
	if (dialogResult.Mode == 1)	
		iWrite = new (ELeave) CFileWrite(dialogResult.fileName, dialogResult.fileSize);
	else
		iWrite = new (ELeave) CFileRead(dialogResult.fileName, dialogResult.fileSize);
	TReal executionTime = iWrite->go();
	CSummaryDialog* dialog2 = new (ELeave) CSummaryDialog(executionTime);
	dialog2 -> ExecuteLD(R_SUMMARY_DIALOG);
	User::Exit(0);
	}


//             The app Ui owns the two views and is. 
//             therefore, responsible for destroying them
//
CRThreadSyncIOAppUi::~CRThreadSyncIOAppUi()
	{
	}


//             Called by the UI framework when a command has been issued.
//             In this example, a command can originate through a 
//             hot-key press or by selection of a menu item.
//             The command Ids are defined in the .hrh file
//             and are 'connected' to the hot-key and menu item in the
//             resource file.
//             Note that the EEikCmdExit is defined by the UI
//             framework and is pulled in by including eikon.hrh
//
void CRThreadSyncIOAppUi::HandleCommandL(TInt)
	{
	
	}


// This is a way to dynamically initialize the menu.
// If it is the debug version, the menu should contain a Close command.
// In the release version, there should be no Close command.
#if defined(_DEBUG)
void CRThreadSyncIOAppUi::DynInitMenuPaneL(TInt, CEikMenuPane*)
	{

	}
#endif
